unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    redOutput: TRichEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
    arrProducts : array[1..20] of string;
    arrPrices : array[1..20] of real;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}




procedure TForm1.Button1Click(Sender: TObject);

var  tf          : Textfile;
     sLine ,stemp : string;
     icount ,i,j : integer;
     rtemp : real;
begin
//read
  AssignFile(tf,'Productprices.txt');
  reset(tf);
  iCount := 0;
  while not eof(tf) and (icount < 20) do
  begin
    readln(tf,sLine);
    inc(icount);
    arrproducts[icount] := copy(sline,1,pos(';',sLine)-1);
    delete (sLine,1,pos(';',sLine));
    arrprices[iCount] := strtofloat(sLine);
  end {while};
  CloseFile(tf);

//simultaneous sort
  for i := 1 to icount - 1 do
    for j := i + 1 to iCount do
      if arrProducts[j] < arrProducts[i] then
      begin
        sTemp  := arrProducts[j];
        arrProducts[j] := arrProducts[i];
        arrProducts[i] := sTemp;

        rTemp  := arrPrices[j];
        arrPrices[j] := arrPrices[i];
        arrPrices[i] := rTemp;
        end;

//display
for i := 1 to icount  do
  redOutput.lines.add(arrproducts[i]+#9+ floattostrf(arrPrices[i],ffcurrency,6,2));

   
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
redOutput.Paragraph.TabCount := 1;
redOutput.Paragraph.Tab[0] := 300;
end;

end.
