unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, ADODB, Grids, DBGrids, StdCtrls, ComCtrls,
  math, Mask, DBCtrls,  
  ExtCtrls;

type
  TForm1 = class(TForm)
    dsrCarRental: TDataSource;
    DbgCars: TDBGrid;
    ADOTblModels: TADOTable;
    conCarRental: TADOConnection;
    cmbTable: TComboBox;
    ADOTblRentals: TADOTable;
    ADOTblGroups: TADOTable;
    pgcCarRentals: TPageControl;
    tbsGrid: TTabSheet;
    tbsAdd: TTabSheet;
    tbsReport: TTabSheet;
    tbsMenu: TTabSheet;
    tbsNavigator: TTabSheet;
    btnGrid: TButton;
    btnAdd: TButton;
    btnReport: TButton;
    btnNavigator: TButton;
    ADOTblModelsModelID: TFloatField;
    ADOTblModelsModelName: TWideStringField;
    ADOTblModelsAC: TBooleanField;
    ADOTblModelsABS_brakes: TBooleanField;
    ADOTblModelsTank: TFloatField;
    ADOTblModelsSeats: TFloatField;
    ADOTblModelsRange: TFloatField;
    ADOTblRentalsID: TAutoIncField;
    ADOTblRentalsCarRegistration: TWideStringField;
    ADOTblRentalsDate_from: TDateTimeField;
    ADOTblRentalsDate_until: TDateTimeField;
    ADOTblRentalsModelID: TFloatField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOTblGroupsGroupID: TWideStringField;
    ADOTblGroupsGroupdescription: TWideStringField;
    ADOTblGroupsRate_per_day: TBCDField;
    DbnCars: TDBNavigator;
    btnLocate: TButton;
    btnFirst: TButton;
    btnnext: TButton;
    btnprevious: TButton;
    btnRecNo: TButton;
    redReport: TRichEdit;
    ADOTblModelsGroupID: TWideStringField;
    ADOTblModelsAUTO: TBooleanField;
    ADOTblModelsPower_Steering: TBooleanField;
    ADOTblModelsCentral_locking: TBooleanField;
    ADOTblModelsAir_Bags: TBooleanField;
    ADOTblModelsDoors: TFloatField;
    MainMenu1: TMainMenu;
    ADOQry: TADOQuery;
    Activity771: TMenuItem;
    N23: TMenuItem;
    N33: TMenuItem;
    N43: TMenuItem;
    N53: TMenuItem;
    N63: TMenuItem;
    N72: TMenuItem;
    N82: TMenuItem;
    N92: TMenuItem;
    cmbgroup: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnGridClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnNavigatorClick(Sender: TObject);
    procedure btnLocateClick(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnnextClick(Sender: TObject);
    procedure btnpreviousClick(Sender: TObject);
    procedure btnRecNoClick(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N63Click(Sender: TObject);
    procedure N92Click(Sender: TObject);
    procedure N33Click(Sender: TObject);
    procedure N43Click(Sender: TObject);
    procedure N53Click(Sender: TObject);
    procedure N72Click(Sender: TObject);
    procedure N82Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.btnAddClick(Sender: TObject);
begin
tbsAdd.show
end;

procedure TForm1.btnGridClick(Sender: TObject);
begin
tbsGrid.show
end;

procedure TForm1.btnLocateClick(Sender: TObject);
var s, seats: string;
    sts : integer;
begin
s:=inputbox('Input','Model name:','');
repeat
seats:=inputbox('Input','seats:','');
until trystrtoint(seats,sts);
If ADOTblModels.Locate('Model Name;Seats', VarArrayOf([s,sts]), [loPartialKey,loCaseInsensitive])
Then showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name'])
Else showmessage('Model name = '+ s +' not found');

end;

procedure TForm1.btnNavigatorClick(Sender: TObject);
begin
tbsNavigator.Show;
end;

procedure TForm1.btnnextClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.next;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnpreviousClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.prior;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnRecNoClick(Sender: TObject);
var sn: string;
    n : integer;
begin
dsrCarRental.DataSet := ADOTblModels;
repeat
 sn := inputbox('Input','Enter record number ','0');
until trystrtoint(sn,n) and (n >=0) and (n <= ADOTblModels.RecordCount);
ADOTblModels.recno := n;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnReportClick(Sender: TObject);
begin
tbsReport.show
end;


procedure TForm1.btnFirstClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.First;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);
end;

procedure TForm1.cmbTableChange(Sender: TObject);
begin
case cmbTable.ItemIndex of
0:  dsrCarRental.DataSet := ADOTblModels;
1:  dsrCarRental.DataSet := ADOTblRentals;
2:  dsrCarRental.DataSet := ADOTblGroups;
end;
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
pgcCarRentals.ActivePage := tbsGrid;
//populate combobox
cmbGroup.Text := 'Choose a group';
ADOTblGroups.First;
while not ADOTblGroups.Eof do
begin
cmbGroup.items.add(ADOTblGroups['Groupid']);
ADOTblGroups.Next;
end;
tbsReport.Show;

redReport.Paragraph.TabCount := 1;
redReport.Paragraph.Tab[0] := 100;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
conCarRental.Close;
conCarRental.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='
+ExtractFilePath(Application.ExeName) +'car rental.mdb;Persist Security Info=False';
conCarRental.LoginPrompt := false;
conCarRental.open;
ADOTblModels.Connection :=  conCarRental;
ADOTblModels.TableName := 'tblmodels';
ADOTblModels.Active := true;
DsrCarrental.DataSet := ADOTblModels;
Dbgcars.DataSource := DsrCarrental;
ADOTblModels.Active := true;
ADOTblRentals.Active := true;
ADOTblGroups.Active := true;
end;

procedure TForm1.N23Click(Sender: TObject);
begin
//complete
end;



procedure TForm1.N33Click(Sender: TObject);
begin
//complete
end;

procedure TForm1.N43Click(Sender: TObject);
var reg : string;
begin
//complete
end;

procedure TForm1.N53Click(Sender: TObject);
begin
//complete
end;



procedure TForm1.N63Click(Sender: TObject);
Var
       days : integer;
begin
//complete
end;

procedure TForm1.N72Click(Sender: TObject);
Var
       days : integer;
       total,count : integer;
begin
//complete
end;

procedure TForm1.N82Click(Sender: TObject);
var aircon, noAircon: integer;
begin
//complete
end;

procedure TForm1.N92Click(Sender: TObject);
Var
       counters : array['A'..'K'] of integer;
  c: Char;
begin
//complete
end;




end.
