unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, ADODB, Grids, DBGrids, StdCtrls, ComCtrls,
  math, Mask, DBCtrls,  
  ExtCtrls;

type
  TForm1 = class(TForm)
    dsrCarRental: TDataSource;
    DbgCars: TDBGrid;
    ADOTblModels: TADOTable;
    conCarRental: TADOConnection;
    cmbTable: TComboBox;
    ADOTblRentals: TADOTable;
    ADOTblGroups: TADOTable;
    pgcCarRentals: TPageControl;
    tbsGrid: TTabSheet;
    tbsAdd: TTabSheet;
    tbsReport: TTabSheet;
    tbsMenu: TTabSheet;
    tbsNavigator: TTabSheet;
    btnGrid: TButton;
    btnAdd: TButton;
    btnReport: TButton;
    btnNavigator: TButton;
    ADOTblModelsModelID: TFloatField;
    ADOTblModelsModelName: TWideStringField;
    ADOTblModelsAC: TBooleanField;
    ADOTblModelsABS_brakes: TBooleanField;
    ADOTblModelsTank: TFloatField;
    ADOTblModelsSeats: TFloatField;
    ADOTblModelsRange: TFloatField;
    ADOTblRentalsID: TAutoIncField;
    ADOTblRentalsCarRegistration: TWideStringField;
    ADOTblRentalsDate_from: TDateTimeField;
    ADOTblRentalsDate_until: TDateTimeField;
    ADOTblRentalsModelID: TFloatField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOTblGroupsGroupID: TWideStringField;
    ADOTblGroupsGroupdescription: TWideStringField;
    ADOTblGroupsRate_per_day: TBCDField;
    DbnCars: TDBNavigator;
    btnLocate: TButton;
    btnFirst: TButton;
    btnnext: TButton;
    btnprevious: TButton;
    btnRecNo: TButton;
    redReport: TRichEdit;
    ADOTblModelsGroupID: TWideStringField;
    ADOTblModelsAUTO: TBooleanField;
    ADOTblModelsPower_Steering: TBooleanField;
    ADOTblModelsCentral_locking: TBooleanField;
    ADOTblModelsAir_Bags: TBooleanField;
    ADOTblModelsDoors: TFloatField;
    MainMenu1: TMainMenu;
    ADOQry: TADOQuery;
    Activity771: TMenuItem;
    N23: TMenuItem;
    N33: TMenuItem;
    N43: TMenuItem;
    N53: TMenuItem;
    N63: TMenuItem;
    N72: TMenuItem;
    N82: TMenuItem;
    N92: TMenuItem;
    cmbgroup: TComboBox;
    Activity791: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnGridClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnNavigatorClick(Sender: TObject);
    procedure btnLocateClick(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnnextClick(Sender: TObject);
    procedure btnpreviousClick(Sender: TObject);
    procedure btnRecNoClick(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N63Click(Sender: TObject);
    procedure N92Click(Sender: TObject);
    procedure N33Click(Sender: TObject);
    procedure N43Click(Sender: TObject);
    procedure N53Click(Sender: TObject);
    procedure N72Click(Sender: TObject);
    procedure N82Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N41Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N61Click(Sender: TObject);
    procedure N71Click(Sender: TObject);
    procedure N81Click(Sender: TObject);
    procedure N91Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure N111Click(Sender: TObject);
    procedure N121Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.btnAddClick(Sender: TObject);
begin
tbsAdd.show
end;

procedure TForm1.btnGridClick(Sender: TObject);
begin
tbsGrid.show
end;

procedure TForm1.btnLocateClick(Sender: TObject);
var s, seats: string;
    sts : integer;
begin
s:=inputbox('Input','Model name:','');
repeat
seats:=inputbox('Input','seats:','');
until trystrtoint(seats,sts);
If ADOTblModels.Locate('Model Name;Seats', VarArrayOf([s,sts]), [loPartialKey,loCaseInsensitive])
Then showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name'])
Else showmessage('Model name = '+ s +' not found');

end;

procedure TForm1.btnNavigatorClick(Sender: TObject);
begin
tbsNavigator.Show;
end;

procedure TForm1.btnnextClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.next;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnpreviousClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.prior;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnRecNoClick(Sender: TObject);
var sn: string;
    n : integer;
begin
dsrCarRental.DataSet := ADOTblModels;
repeat
 sn := inputbox('Input','Enter record number ','0');
until trystrtoint(sn,n) and (n >=0) and (n <= ADOTblModels.RecordCount);
ADOTblModels.recno := n;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);

end;

procedure TForm1.btnReportClick(Sender: TObject);
begin
tbsReport.show
end;


procedure TForm1.btnFirstClick(Sender: TObject);
begin
dsrCarRental.DataSet := ADOTblModels;
ADOTblModels.First;
showmessage(inttostr(ADOTblModels['modelID'])+ #9+ADOTblModels['model name']);
end;

procedure TForm1.cmbTableChange(Sender: TObject);
begin
case cmbTable.ItemIndex of
0:  dsrCarRental.DataSet := ADOTblModels;
1:  dsrCarRental.DataSet := ADOTblRentals;
2:  dsrCarRental.DataSet := ADOTblGroups;
end;
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
pgcCarRentals.ActivePage := tbsGrid;
//populate combobox
cmbGroup.Text := 'Choose a group';
ADOTblGroups.First;
while not ADOTblGroups.Eof do
begin
cmbGroup.items.add(ADOTblGroups['Groupid']);
ADOTblGroups.Next;
end;

redReport.Paragraph.TabCount := 1;
redReport.Paragraph.Tab[0] := 100;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
conCarRental.Close;
conCarRental.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='
+ExtractFilePath(Application.ExeName) +'car rental.mdb;Persist Security Info=False';
conCarRental.LoginPrompt := false;
conCarRental.open;
ADOTblModels.Connection :=  conCarRental;
ADOTblModels.TableName := 'tblmodels';
ADOTblModels.Active := true;
DsrCarrental.DataSet := ADOTblModels;
Dbgcars.DataSource := DsrCarrental;
ADOTblModels.Active := true;
ADOTblRentals.Active := true;
ADOTblGroups.Active := true;
end;

procedure TForm1.N101Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := '[a/c] = true and auto = true';
ADOTblModels.Filtered := true;
end;

procedure TForm1.N111Click(Sender: TObject);
var m : string;
begin
m := inputbox('Input','Please enter the model name','VW Chico');
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := '[model name] ='''+m+'''';
ADOTblModels.Filtered := true;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblgroups;
ADOTblGroups.Filtered := false;
ADOTblgroups.Filter := 'Groupid = ''A''OR Groupid = ''B''';
ADOTblgroups.Filtered := true;
end;

procedure TForm1.N121Click(Sender: TObject);
var n : string;
begin
n := inputbox('Input','Please enter the number of seats','2');
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := 'seats ='+n;
ADOTblModels.Filtered := true;
end;

procedure TForm1.N21Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblrentals;
ADOTblRentals.Filtered := false;
ADOTblRentals.Filter := 'date_from = #2013/10/07#';
ADOTblRentals.Filtered := true;
end;

procedure TForm1.N23Click(Sender: TObject);
begin
adotblmodels.open;
adotblmodels.First;
redReport.clear;
redReport.lines.add('Group '+cmbGroup.Text);
while not adotblmodels.Eof do
	begin
  if adotblmodels['groupid'] = cmbGroup.Text then
  redReport.lines.add(adotblmodels['Model name']);
	adotblmodels.Next;
	end;
end;



procedure TForm1.N31Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblrentals;
ADOTblRentals.Filtered := false;
ADOTblRentals.Filter := 'date_from >=#2013/10/03# and date_from <=#2013/10/10#';
ADOTblRentals.Filtered := true;
end;

procedure TForm1.N33Click(Sender: TObject);
begin
adotblmodels.open;
adotblmodels.First;
redReport.clear;
redReport.lines.add('Models with air-conditioning');
while not adotblmodels.Eof do
	begin
  if adotblmodels['a/c'] = true then
  redReport.lines.add(adotblmodels['Model name']);
	adotblmodels.Next;
	end;
end;

procedure TForm1.N41Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblrentals;
ADOTblRentals.Filtered := false;
ADOTblRentals.Filter := 'carregistration like ''%KZN%''';
ADOTblRentals.Filtered := true;
end;

procedure TForm1.N43Click(Sender: TObject);
var reg : string;
begin
adotblrentals.open;
adotblrentals.First;
redReport.clear;
redReport.lines.add('Cars from KZN');
while not adotblrentals.Eof do
	begin
  reg := adotblrentals['carregistration'] ;
  if copy(reg,length(reg)-2,3) = 'KZN' then
  redReport.lines.add(adotblrentals['carregistration']);
	adotblrentals.Next;
	end;
end;

procedure TForm1.N51Click(Sender: TObject);
var d : string;
begin
dsrCarRental.DataSet := ADOtblrentals;
ADOTblRentals.Filtered := false;
D := inputbox('Input','Please enter a date in the format yyyy/mm/dd','');
ADOTblRentals.Filter := 'date_from = #'+ d + '#';
ADOTblRentals.Filtered := true;
end;

procedure TForm1.N53Click(Sender: TObject);
begin
adotblmodels.open;
adotblmodels.First;
redReport.clear;
redReport.lines.add('Models and fuel consumption');
while not adotblmodels.Eof do
	begin
  try
  redReport.lines.add(adotblmodels['Model name']+#9+ floattostrf(adotblmodels['range']/adotblmodels['tank'],ffFixed,6,1)+'km/l');
  except
  redReport.lines.add(adotblmodels['Model name']+#9+ 'data not available');
  end;
	adotblmodels.Next;
	end;
end;



procedure TForm1.N61Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblModels;
ADOtblModels.Filtered := false;
ADOtblModels.Filter := 'seats <> 4';
ADOtblModels.Filtered := true;
end;

procedure TForm1.N63Click(Sender: TObject);
Var
       days : integer;
begin
adotblrentals.open;
adotblrentals.First;
redreport.lines.add('Carregistration'+#9+ 'Days');
while not adotblrentals.Eof do
	begin
	days := adotblrentals['date_until']- adotblrentals['date_from'];
	redreport.lines.add(adotblrentals['carregistration']+#9+ inttostr(days));
	adotblrentals.Next;
	end
end;

procedure TForm1.N71Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := 'tank > 40 and seats = 4';
ADOTblModels.Filtered := true;
end;

procedure TForm1.N72Click(Sender: TObject);
Var
       days : integer;
       total,count : integer;
begin
total := 0;
days:= 0;
count := 0;
adotblrentals.open;
adotblrentals.First;
redReport.Clear;
redreport.lines.add('Carregistration'+#9+ 'Days');
while not adotblrentals.Eof do
	begin
	days := adotblrentals['date_until']- adotblrentals['date_from'];
  total := total + days;
  inc(count);
	redreport.lines.add(adotblrentals['carregistration']+#9+ inttostr(days));
	adotblrentals.Next;
	end   ;
redreport.lines.add('Average number of days'+floattostrf(total/count,fffixed,6,1));
end;

procedure TForm1.N81Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := '[model name] like ''T%'' or [model name] like ''V%''';
ADOTblModels.Filtered := true;
end;

procedure TForm1.N82Click(Sender: TObject);
var aircon, noAircon: integer;
begin
aircon := 0;
noaircon := 0;
adotblmodels.open;
adotblmodels.First;
redReport.clear;
redReport.lines.add('Models with air-conditioning');
while not adotblmodels.Eof do
	begin
  if adotblmodels['a/c'] = true then
      inc(aircon)
      else
      inc(noAircon);
	adotblmodels.Next;
	end;
redReport.lines.add('Number of models with air-con   '+ #9+inttostr(aircon));
redReport.lines.add('Number of models without air-con'+ #9+inttostr(noaircon));
end;

procedure TForm1.N91Click(Sender: TObject);
begin
dsrCarRental.DataSet := ADOtblModels;
ADOTblModels.Filtered := false;
ADOTblModels.Filter := '[model name] =''Toyota Yaris T1''';
ADOTblModels.Filtered := true;
end;

procedure TForm1.N92Click(Sender: TObject);
Var
       counters : array['A'..'K'] of integer;
  c: Char;
begin
for c := 'A' to 'K' do
    counters[c] := 0;

adotblmodels.open;
adotblmodels.First;
while not adotblmodels.Eof do
	begin
  c:= adotblmodels.FieldByName('groupid').AsString[1];
	inc(counters[c]);
	adotblmodels.Next;
	end;
for c := 'A' to 'K' do
   if counters[c] <> 0 then redreport.Lines.Add('Group '+c+#9+ inttostr(counters[c]))
end;




end.
