unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, dateutils;

type
  TForm1 = class(TForm)
    btnValidate: TButton;
    edtId: TEdit;
    redOutput: TRichEdit;
    procedure btnValidateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function Valid (sID: string) :boolean;
    function age(sID: string) : integer;
    function dateofbirth(sID: string) : string;
    function gender(sID: string) : string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.btnValidateClick(Sender: TObject);
var ID : string;
begin
ID := edtId.Text;
if valid(ID) then
  redOutput.lines.add(ID+#9+dateofbirth(ID)+#9+gender(ID)+#9+inttostr(age(ID)))
else
   redOutput.lines.add('Invalid ID');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
redOutput.Paragraph.TabCount := 4;
redOutput.Paragraph.Tab[0] := 50;
redOutput.Paragraph.Tab[1] := 100;
redOutput.Paragraph.Tab[2] := 150;
redOutput.Paragraph.Tab[3] := 200;
end;


end.
