unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, ADODB, Grids, DBGrids, StdCtrls, ComCtrls,
  math, Mask, DBCtrls,  
  ExtCtrls;

type
  TForm1 = class(TForm)
    dsrCarRental: TDataSource;
    DbgCars: TDBGrid;
    ADOTblModels: TADOTable;
    conCarRental: TADOConnection;
    cmbTable: TComboBox;
    ADOTblRentals: TADOTable;
    ADOTblGroups: TADOTable;
    pgcCarRentals: TPageControl;
    tbsGrid: TTabSheet;
    tbsAdd: TTabSheet;
    tbsReport: TTabSheet;
    tbsMenu: TTabSheet;
    tbsNavigator: TTabSheet;
    btnGrid: TButton;
    btnAdd: TButton;
    btnReport: TButton;
    btnNavigator: TButton;
    ADOTblModelsModelID: TFloatField;
    ADOTblModelsModelName: TWideStringField;
    ADOTblModelsAC: TBooleanField;
    ADOTblModelsABS_brakes: TBooleanField;
    ADOTblModelsTank: TFloatField;
    ADOTblModelsSeats: TFloatField;
    ADOTblModelsRange: TFloatField;
    ADOTblRentalsID: TAutoIncField;
    ADOTblRentalsCarRegistration: TWideStringField;
    ADOTblRentalsDate_from: TDateTimeField;
    ADOTblRentalsDate_until: TDateTimeField;
    ADOTblRentalsModelID: TFloatField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOTblGroupsGroupID: TWideStringField;
    ADOTblGroupsGroupdescription: TWideStringField;
    ADOTblGroupsRate_per_day: TBCDField;
    DbnCars: TDBNavigator;
    redReport: TRichEdit;
    ADOTblModelsGroupID: TWideStringField;
    DateTimePicker1: TDateTimePicker;
    ADOTblModelsAUTO: TBooleanField;
    ADOTblModelsPower_Steering: TBooleanField;
    ADOTblModelsCentral_locking: TBooleanField;
    ADOTblModelsAir_Bags: TBooleanField;
    ADOTblModelsDoors: TFloatField;
    cmbGroups: TComboBox;
    ADOQry: TADOQuery;
    procedure FormCreate(Sender: TObject);
    procedure cmbTableChange(Sender: TObject);
    procedure btnGridClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnNavigatorClick(Sender: TObject);



  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}




procedure TForm1.btnAddClick(Sender: TObject);
begin
tbsAdd.show
end;

procedure TForm1.btnGridClick(Sender: TObject);
begin
tbsGrid.show
end;


procedure TForm1.btnNavigatorClick(Sender: TObject);
begin
tbsNavigator.Show;
end;



procedure TForm1.btnReportClick(Sender: TObject);
begin
tbsReport.show
end;




procedure TForm1.cmbTableChange(Sender: TObject);
begin
case cmbTable.ItemIndex of
0:  dsrCarRental.DataSet := ADOTblModels;
1:  dsrCarRental.DataSet := ADOTblRentals;
2:  dsrCarRental.DataSet := ADOTblGroups;
end;
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
conCarRental.Close;
conCarRental.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source='
+ExtractFilePath(Application.ExeName) +'car rental.mdb;Persist Security Info=False';
conCarRental.LoginPrompt := false;
conCarRental.open;
ADOTblModels.Connection :=  conCarRental;
ADOTblModels.TableName := 'tblmodels';
ADOTblModels.Active := true;
DsrCarrental.DataSet := ADOTblModels;
Dbgcars.DataSource := DsrCarrental;
ADOTblModels.Active := true;
ADOTblRentals.Active := true;
ADOTblGroups.Active := true;
end;





end.
